Subject: nexthop calculations

From: j j <[email-masked]>
Date: Sun, 22 Dec 2002 10:39:49 -0800

But ultimately the nexthop records for router
vertices get used to determine routes to stub networks
being advertised by that particular router and during
inter-area route calcuations.
Because as I understand it router vertices are ignored
as far as populating RIB goes.  Only network vertices
are considered.

true?

Second question to anybody who is familiar with zebra
code.  In ospf_nexthop_calculation(), for a directly
connected (via point-to-point link) child router
vertex, zebra does following :

for each link L1 in parent's router lsa pointing to
child
{
    for each link L2 in child's router lsa pointing to
parent {
       get interface associated with L2->link_data;
       if (interface->addr == L1->link_data)
            create new nexthop;
    }
}

two questions -
first of all if parent had 4 parallel links to the
child above code will create 16 nexthops. no?

second isn't interface->addr == L1->link_data check
redundant?

I would appreciate the clarification.

thanks

jasmine

>> Jasmine,

>> The information used immediately is the outgoing
>> interface. Besides, at this stage the nexthop
>> address can be retrieved from the link data of the
>> directly connected router vertex. This nexthop
>> address is used later, when a remote vertex
>> inherits nexthops to the directly connected router
>> vertices.

>> Thanks,
>> Igor

 --- j j <[email-masked]> wrote:
>Igor,
>
>Why is it necessary to record nexthops for routers
>connected via network to the root?  Where is this
>information used?
>is it used to process stub links or inter-area
>route calcuations?
>
>thanks
>
>jasmine
>
>--- Igor Miroshnik <[email-masked]> wrote:
>> On Sat, 21 Dec 2002 10:46:51 -0800, j j
>> <[email-masked]> wrote:
>>
>> >hello folks,
>> >
>> >I am going through Zebra and Moy's source code for
>> >OSPFv2.  The question I have is when calculating
>> >next hops for a router vertex that is directly
>> >connected to the root (i.e. calculating router)
via
>> >a network vertex, why can't we simply inherit the
>> >nexthops of the network vertex ? Moy and Zebra
both
>> >do something special for this case which I cannot
>> >understand.
>> >
>> >It seems like the root should be able to reach the
>> >router through all the nexthops that were
>> calculated
>> >for the network vertex.
>> >
>> >I hope I was able to clearly explain my doubts.
>> >
>> >thanks
>> >
>> >jasmine
>>
>> Jasmine,
>>
>> The nexthop address for a router vertex via a
>> network one is the IP address of the destination
>> router on the network mentioned, whereas the
nexthop
>> address for a network vertex directly connected
>> to the root is not. Actually, the latter does not
>> have any nexthop. That is why we can't simply
>> inherit the nexthops of that network vertex. In our
>> implementation, that nexthop's address is zero.
>>
>> Thanks,
>> Igor

__________________________________________________
Do you Yahoo!?
Yahoo! Mail Plus - Powerful. Affordable. Sign up now.
http://mailplus.yahoo.com